using System;
using System.Data;
using System.Data.SqlClient;

namespace OrderEntryDAL
{
	public class Dal:MarshalByRefObject
	{
		private string ConnectionString;
		private SqlConnection cnn;
		private SqlCommand cmd;
		private SqlDataAdapter da;

		public Dal()
		{
			ConnectionString="User ID=sa;Initial Catalog=DOTNETTrng;Data Source=ind-spz4dnt0388\\netsdk";

			cnn=new SqlConnection(ConnectionString);
			cmd=new SqlCommand();
			cmd.Connection=cnn;
			da=new SqlDataAdapter();
			Console.WriteLine("DAL Constructor...");
		}

		public DataSet GetProductList()
		{
			DataSet ds=new DataSet();
			da.SelectCommand=new SqlCommand();
			da.SelectCommand.CommandText="select * from products";
			da.SelectCommand.Connection=cnn;
			da.Fill(ds,"products");
			return ds;
		}

		public int InsertOrder(DataSet dsOrder)
		{
			int orderid=-1;
			bool isfirst=true;

			try
			{
				cnn.Open();
				cmd.Transaction=cnn.BeginTransaction();
				foreach(DataRow r in dsOrder.Tables[0].Rows)
				{
					if(isfirst==true)
					{
						cmd.CommandText="select isnull(max(orderid),0) from orders";
						object o=cmd.ExecuteScalar();
						if(o!=null)
							orderid=(int)o;
						Console.WriteLine(orderid);
						orderid++;
						isfirst=false;
					}
					cmd.CommandText="insert into orders(orderid,productid,departmentid,qty,status) values(" + orderid + "," + r["productid"] + "," + r["departmentid"] + "," + r["qty"] + ",'P')";
					cmd.ExecuteNonQuery();
					cmd.CommandText="update products set productqtyinstock=productqtyinstock-" + r["qty"] + " where productid=" + r["productid"];
					cmd.ExecuteNonQuery();
				}
				cmd.Transaction.Commit();
				cnn.Close();
				return orderid;
			}
			catch(Exception e)
			{
				Console.WriteLine(e.Message);
				return -1;
			}
			
		}

		public char GetOrderStatus(int orderid)
		{
			char orderstatus;
			cnn.Open();
			cmd.CommandText="select top 1 status from orders where orderid=" + orderid;
			orderstatus=(char)cmd.ExecuteScalar();
			cnn.Close();
			return orderstatus;
		}

		public int QtyInStock(int productid)
		{
			int qtyinstock=0;
			cnn.Open();
			cmd.CommandText="select productqtyinstock from products where productid=" + productid;
			qtyinstock=(int)cmd.ExecuteScalar();
			cnn.Close();
			return qtyinstock;
		}


	}
}
