using System;
using System.Data;
using System.Data.SqlClient;
using OrderEntryDAL;

namespace OrderEntryBOL
{
	public class Bol:MarshalByRefObject
	{
		private Dal db;

		public Bol()
		{
			db=(Dal)Activator.GetObject(typeof(OrderEntryDAL.Dal),"tcp://localhost:8085/MyDalURI");
			if(db==null)
				Console.WriteLine("db is null");
			else
				Console.WriteLine("db is not null");
		}

		public int PlaceOrder(DataSet dsOrder)
		{
			Console.WriteLine("inside placeorder...");
			int productid,qtyinstock;

			foreach(DataRow r in dsOrder.Tables[0].Rows)
			{
				productid=(int)r["productid"];
				Console.WriteLine("product id is " + productid);
				qtyinstock=db.QtyInStock(productid);
				switch(productid)
				{
					case 1:
						if(qtyinstock<10)
							return -1;
						break;
					case 2:
						if(qtyinstock<10)
							return -1;
						break;
					case 3:
						if(qtyinstock<10)
							return -1;
						break;
					case 4:
						if(qtyinstock<10)
							return -1;
						break;
				}
			}
			return db.InsertOrder(dsOrder);
		}

		public DataSet GetProductList()
		{
			return db.GetProductList();
		}

	}
}
