using System;
using System.Reflection;
using System.Runtime.Remoting;
using System.Runtime.Remoting.Channels;
using System.Runtime.Remoting.Channels.Tcp;

namespace OrderEntryDALStarter
{
	class DALStarter
	{
		static void Main(string[] args)
		{
			TcpChannel chan = new TcpChannel(8085);
			ChannelServices.RegisterChannel(chan);
			RemotingConfiguration.RegisterWellKnownServiceType(typeof(OrderEntryDAL.Dal),"MyDalURI",WellKnownObjectMode.SingleCall);
			Console.WriteLine("OrderEntryDAL.Dal Published...");
			Console.ReadLine();
		}
	}
}
